/////////////////////////////////////////////////////////////////////////////
// Name:        Step1Dlg.cpp
// Purpose:     
// Author:      Gregory Silber gsilber@marsnet.com
// Modified by: Marco Cavallini m.cavallini@koansoftware.com
// Created:     
// RCS-ID:      
// Copyright:   
// Licence:     wxWindows
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "wxWinWiz.h"
#include "wxWinWizAw.h"
#include "Step1Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
extern CWxWinWizAppWiz WxWinWizaw;
/////////////////////////////////////////////////////////////////////////////
// CStep1Dlg dialog


CStep1Dlg::CStep1Dlg(CWnd* pParent /*=NULL*/)
	: CAppWizStepDlg(CStep1Dlg::IDD)
{
	//{{AFX_DATA_INIT(CStep1Dlg)
	m_wxbasedir = _T("");
	//}}AFX_DATA_INIT
}


void CStep1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CAppWizStepDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStep1Dlg)
	DDX_Control(pDX, IDC_WXBASEDIR, m_wxbasedir_ctrl);
	DDX_Text(pDX, IDC_WXBASEDIR, m_wxbasedir);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStep1Dlg, CAppWizStepDlg)
	//{{AFX_MSG_MAP(CStep1Dlg)
	ON_BN_CLICKED(IDC_BASEDIRBROWSE, OnBasedirbrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStep1Dlg message handlers

BOOL CStep1Dlg::OnDismiss()
{
	UpdateData(TRUE);
    
    HKEY key;
    char* type = "REG_SZ";
    DWORD disp;
    if (ERROR_SUCCESS == RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\wxWindows\\wxWinWizard", 0, type, REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &key, &disp)) {
        RegSetValueEx(key, "wxbasedir", 0, REG_SZ, (CONST BYTE *) ((LPCTSTR) m_wxbasedir), m_wxbasedir.GetLength());
        RegCloseKey(key);
    }

    WxWinWizaw.m_Dictionary[_T("wxbasedir")] = m_wxbasedir;

	CButton* btn;
	btn=(CButton*)GetDlgItem(IDC_MOTIF);
	if (btn->GetCheck()==TRUE)
		WxWinWizaw.m_Dictionary[_T("unixtype")] = "__WXMOTIF__";
	else
		WxWinWizaw.m_Dictionary[_T("unixtype")] = "__WXGTK__";

	return TRUE;
}

void CStep1Dlg::OnBasedirbrowse() 
{
//    CFileDialog fileDialog(TRUE);
//    int result = fileDialog.DoModal();
//    CString file = fileDialog.GetPathName();
//    int slashAt = file.ReverseFind('\\');
//    CString directory;
//    if (slashAt != -1)
//        directory = file.Left(slashAt);
//    else
//        directory = file;
//    m_wxbasedir_ctrl.SetWindowText(directory);

    char buffer[MAX_PATH];
    int image = 0;
    BROWSEINFO bi;
    bi.hwndOwner = m_hWnd;
    bi.pszDisplayName = buffer;
    bi.lpszTitle = "Please locate the top level folder of wxWindows";
    bi.ulFlags = BIF_RETURNONLYFSDIRS;
    bi.lpfn = NULL;
    bi.lParam = 0;
    bi.iImage = image;
    bi.pidlRoot = NULL;

    LPITEMIDLIST itemList = SHBrowseForFolder(&bi);
    if (itemList) {
        BOOL ok = SHGetPathFromIDList(itemList, buffer);
        LPMALLOC malloc;
        SHGetMalloc(&malloc);
        if (malloc) {
            malloc->Free(itemList);
            malloc->Release();
        }
        m_wxbasedir_ctrl.SetWindowText(buffer);
    }

}

BOOL CStep1Dlg::OnInitDialog() 
{
	CAppWizStepDlg::OnInitDialog();
	
    HKEY key;

    // set initial variable states
    if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\wxWindows\\wxWinWizard", 0, KEY_READ, &key)) {
        char buffer[1024];
        DWORD bufferSize = 1024;
        DWORD type = REG_SZ;
        strcpy(buffer, "");
        RegQueryValueEx(key, "wxbasedir", NULL, &type, (LPBYTE) buffer, &bufferSize);
        RegCloseKey(key);

        m_wxbasedir = buffer;
    }
    else {
        m_wxbasedir = WxWinWizaw.m_Dictionary[_T("wxbasedir")];
    }

    CButton* btn;

    btn=(CButton*)GetDlgItem(IDC_MOTIF);
    if (WxWinWizaw.m_Dictionary[_T("unixtype")] == "__WXMOTIF__")
	    btn->SetCheck(TRUE);
    else
        btn->SetCheck(FALSE);
    btn=(CButton*)GetDlgItem(IDC_GTK2);
    if (WxWinWizaw.m_Dictionary[_T("unixtype")] == "__WXGTK__")
	    btn->SetCheck(TRUE);
    else
        btn->SetCheck(FALSE);
	
    UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

