/////////////////////////////////////////////////////////////////////////////
// Name:        Step3Dlg.cpp
// Purpose:     
// Author:      Gregory Silber gsilber@marsnet.com
// Modified by: Marco Cavallini m.cavallini@koansoftware.com
// Created:     
// RCS-ID:      
// Copyright:   
// Licence:     wxWindows
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "wxWinWiz.h"
#include "wxWinWizAw.h"
#include "Step3Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStep3Dlg dialog


CStep3Dlg::CStep3Dlg(CWnd* pParent /*=NULL*/)
	: CAppWizStepDlg(CStep3Dlg::IDD)
{
	//{{AFX_DATA_INIT(CStep3Dlg)
	m_title = _T("");
	m_caption = _T("");
	//}}AFX_DATA_INIT
}


void CStep3Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStep3Dlg)
	DDX_Control(pDX, IDC_TOOLBAR, m_toolbar_ctrl);
	DDX_Control(pDX, IDC_STATUSBAR, m_statusbar_ctrl);
	DDX_Control(pDX, IDC_MENUBAR, m_menubar_ctrl);
	DDX_Control(pDX, IDC_XRC, m_xrc_ctrl);
	DDX_Text(pDX, IDC_TITLE, m_title);
	DDX_Text(pDX, IDC_CAPTION, m_caption);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStep3Dlg, CDialog)
	//{{AFX_MSG_MAP(CStep3Dlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStep3Dlg message handlers

BOOL CStep3Dlg::OnDismiss()
{
	UpdateData(TRUE);
	
    WxWinWizaw.m_Dictionary[_T("wintitle")] = m_title;
    WxWinWizaw.m_Dictionary[_T("caption")] = m_caption;

    if (m_menubar_ctrl.GetCheck()==TRUE)
		WxWinWizaw.m_Dictionary[_T("menubar")] = "1";
	else
		WxWinWizaw.m_Dictionary.RemoveKey(_T("menubar"));

    if (m_xrc_ctrl.GetCheck()==TRUE)
		WxWinWizaw.m_Dictionary[_T("usexrc")] = "1";
	else
		WxWinWizaw.m_Dictionary.RemoveKey(_T("usexrc"));

    if (m_statusbar_ctrl.GetCheck()==TRUE)
		WxWinWizaw.m_Dictionary[_T("statusbar")] = "1";
	else
		WxWinWizaw.m_Dictionary.RemoveKey(_T("statusbar"));

    if (m_toolbar_ctrl.GetCheck()==TRUE)
		WxWinWizaw.m_Dictionary[_T("toolbar")] = "1";
	else
		WxWinWizaw.m_Dictionary.RemoveKey(_T("toolbar"));

    return TRUE;
}


BOOL CStep3Dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    m_title = WxWinWizaw.m_Dictionary[_T("title")];
    m_caption = WxWinWizaw.m_Dictionary[_T("caption")];

    if (WxWinWizaw.m_Dictionary[_T("usexrc")] == "1")
        m_xrc_ctrl.SetCheck(TRUE);
    else
        m_xrc_ctrl.SetCheck(FALSE);
    if (WxWinWizaw.m_Dictionary[_T("dialogproject")] == "1") {
        m_menubar_ctrl.EnableWindow(FALSE);
        m_statusbar_ctrl.EnableWindow(FALSE);
        m_toolbar_ctrl.EnableWindow(FALSE);
    }
    else {
        if (WxWinWizaw.m_Dictionary[_T("menubar")] == "1")
            m_menubar_ctrl.SetCheck(TRUE);
        else
            m_menubar_ctrl.SetCheck(FALSE);
        if (WxWinWizaw.m_Dictionary[_T("statusbar")] == "1")
            m_statusbar_ctrl.SetCheck(TRUE);
        else
            m_statusbar_ctrl.SetCheck(FALSE);
        if (WxWinWizaw.m_Dictionary[_T("toolbar")] == "1")
            m_toolbar_ctrl.SetCheck(TRUE);
        else
            m_toolbar_ctrl.SetCheck(FALSE);
    }
    
    UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
