/////////////////////////////////////////////////////////////////////////////
// Name:        wxWinWiz.cpp
// Purpose:     Defines the initialization routines for the DLL
// Author:      Gregory Silber gsilber@marsnet.com
// Modified by: Marco Cavallini m.cavallini@koansoftware.com
// Created:     
// RCS-ID:      
// Copyright:   
// Licence:     wxWindows
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <afxdllx.h>
#include "wxWinWiz.h"
#include "wxWinWizaw.h"

#ifdef _PSEUDO_DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static AFX_EXTENSION_MODULE WxWinWizDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("WXWINWIZ.AWX Initializing!\n");
		
		// Extension DLL one-time initialization
		AfxInitExtensionModule(WxWinWizDLL, hInstance);

		// Insert this DLL into the resource chain
		new CDynLinkLibrary(WxWinWizDLL);

		// Register this custom AppWizard with MFCAPWZ.DLL
		SetCustomAppWizClass(&WxWinWizaw);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("WXWINWIZ.AWX Terminating!\n");

		// Terminate the library before destructors are called
		AfxTermExtensionModule(WxWinWizDLL);
	}
	return 1;   // ok
}
