/////////////////////////////////////////////////////////////////////////////
// Name:        wxWinWizAw.cpp
// Purpose:     implementation file
// Author:      Gregory Silber gsilber@marsnet.com
// Modified by: (3/8/2003) Marco Cavallini wx@koansoftware.com
//				added DLL configurations
//				(10/11/2004) KoanSoftware.com
//				added patches by Geoff Beier gbeier@orionsec.com
//				and solved other DLL related bugs and added new features
//
// Created:     
// RCS-ID:      
// Copyright:   
// Licence:     wxWindows
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "wxWinWiz.h"
#include "wxWinWizaw.h"
#include "step0dlg.h"
#include "step1dlg.h"
#include "step2dlg.h"
#include "step3dlg.h"

#include "objmodel\bldauto.h"
#include "objmodel\bldguid.h"
#include "objmodel\blddefs.h"
#include "comdef.h"

#ifdef _PSEUDO_DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// Here we define one instance of the CWxWinWizAppWiz class.  You can access
//  m_Dictionary and any other public members of this class through the
//  global WxWinWizaw.
CWxWinWizAppWiz WxWinWizaw;



// This is called immediately after the custom AppWizard is loaded.  Initialize
//  the state of the custom AppWizard here.
void CWxWinWizAppWiz::InitCustomAppWiz()
{
	// IMPORTANT !!! defines the number of dialog steps
	SetNumberOfSteps(4);


	// Add build step to .hpj if there is one
	m_Dictionary[_T("HELP")] = _T("1");
	m_Dictionary[_T("PROJTYPE_CON")] = _T("1");

    // page 0 defaults
	// does nothing important

    // page 1 defaults
    m_Dictionary[_T("wxbasedir")] = _T("c:\\wx-2.4.2");
	m_Dictionary[_T("unixtype")] = "__WXGTK__";

    // page 2 defaults
	m_Dictionary[_T("singledocument")] = "1";

    // page 3 defaults
	m_Dictionary[_T("caption")] = _T("Ready");
    m_Dictionary[_T("title")] = _T("wxWindows Application Title");
	m_Dictionary[_T("usexrc")] = "0";
    m_Dictionary[_T("statusbar")] = "1";
    m_Dictionary[_T("menubar")] = "1";
    m_Dictionary[_T("toolbar")] = "1";

}

////////////////////////////////////////////////////////////////////
// This is called just before the custom AppWizard is unloaded.
////////////////////////////////////////////////////////////////////
// By default Output and Intermediate directory name for 
// DebugDLL and ReleaseDLL mode are set to 
// <projectname>__WIN32_DebugDLL and <projectname>__WIN32_ReleaseDLL
// There is no way to set output_dir and intermediate_dir with
// AddToolSettings so we have to parse the dsp project file
// at the end of the wizard
////////////////////////////////////////////////////////////////////
void CWxWinWizAppWiz::ExitCustomAppWiz()
{
	FILE *fpsrc ;
	FILE *fpdest ;

	char buff[255] ;

	CString src ;
	CString found ;
	src.Format("%s.dsp", m_sProject_Name) ;
	CString dest("project.bak");

	// Fist we rename the original DSP file
	CFile::Rename(src, dest) ;


	if (fpsrc = fopen(dest, "r"))	//open project.bak file
	{
		if (fpdest = fopen(src, "w"))	//create new <projectname>.dsp
		{
			while (fgets(buff, 100, fpsrc) )
			{
				if ( strstr(buff, BASE_OUTPUT_STR) != NULL) // is BASE output_dir
				{
					if (strstr(buff ,RELEASE_DLL) != NULL )	//releasedll
						strcpy(buff, BASE_RELDLL_SUBSTR_OUT) ; 
					else if (strstr(buff ,DEBUG_DLL) != NULL )	//debugdll
						strcpy(buff, BASE_DEBDLL_SUBSTR_OUT) ;
				}
				else if ( strstr(buff, PROP_OUTPUT_STR) != NULL) // is PROP output_dir
				{
					if (strstr(buff ,RELEASE_DLL) != NULL )	//releasedll
						strcpy(buff, PROP_RELDLL_SUBSTR_OUT) ; 
					else if (strstr(buff ,DEBUG_DLL) != NULL )	//debugdll
						strcpy(buff, PROP_DEBDLL_SUBSTR_OUT) ;
				}
				else if ( strstr(buff, BASE_INTERMEDIATE_STR) != NULL) // is BASE intermediate
				{
					if (strstr(buff ,RELEASE_DLL) != NULL )	//releasedll
						strcpy(buff, BASE_RELDLL_SUBSTR_INT) ; 
					else if (strstr(buff ,DEBUG_DLL) != NULL )	//debugdll
						strcpy(buff, BASE_DEBDLL_SUBSTR_INT) ;
				}
				else if ( strstr(buff, PROP_INTERMEDIATE_STR) != NULL) // is PROP intermediate
				{
					if (strstr(buff ,RELEASE_DLL) != NULL )	//releasedll
						strcpy(buff, PROP_RELDLL_SUBSTR_INT) ; 
					else if (strstr(buff ,DEBUG_DLL) != NULL )	//debugdll
						strcpy(buff, PROP_DEBDLL_SUBSTR_INT) ;
				}

				fputs(buff, fpdest) ;
			}
			fclose(fpdest) ;
		}

		fclose(fpsrc) ;

		//remove project.bak file
		CFile::Remove(dest) ;
	}

	
	// Final message
	CString msg ;
	msg =  "   *** wxWinWizard warning ***   \n" ;
	msg += "Project creation completed\n" ;
	msg += "Please close and reopen MS Visual C++\n" ;
	msg += "before start using this project" ;
	AfxMessageBox(msg) ;

}


///////////////////////////////
//			BACK
///////////////////////////////
CAppWizStepDlg* CWxWinWizAppWiz::Back(CAppWizStepDlg* pDlg)
{
	// Return NULL to indicate there are no more steps.
	if (pDlg==NULL)
	{
        if (m_Dictionary[_T("emptyproject")] == "1") {
		    CStep2Dlg * dlg=NULL;
		    dlg=new CStep2Dlg;
		    return dlg;
        }
        else {
		    CStep3Dlg * dlg=NULL;
		    dlg=new CStep3Dlg;
		    return dlg;
        }
	}
	if (pDlg->m_nIDTemplate==CStep3Dlg::IDD)
	{
		CStep2Dlg * dlg=NULL;
		dlg=new CStep2Dlg;
		return dlg;
	}
	if (pDlg->m_nIDTemplate==CStep2Dlg::IDD)
	{
		CStep1Dlg * dlg=NULL;
		dlg=new CStep1Dlg;
		return dlg;
	}
	if (pDlg->m_nIDTemplate==CStep1Dlg::IDD)
	{
		CStep0Dlg * dlg=NULL;
		dlg=new CStep0Dlg;
		return dlg;
	}

	return NULL;
}

/////////////////////////////////////////////////////////////////////////////
// This is called when the user clicks "Create..." on the New Project dialog
/////////////////////////////////////////////////////////////////////////////
CAppWizStepDlg* CWxWinWizAppWiz::Next(CAppWizStepDlg* pDlg)
{
	// Get value of $$root$$ (already set by AppWizard)
	CString strRoot;
	m_Dictionary.Lookup(_T("root"), strRoot);
	
	// Set value of $$Doc$$, $$DOC$$
	CString strDoc = strRoot.Left(6);
	m_Dictionary[_T("Doc")] = strDoc;
	strDoc.MakeUpper();
	m_Dictionary[_T("DOC")] = strDoc;

	// Set value of $$MAC_TYPE$$
	strRoot = strRoot.Left(4);
	int nLen = strRoot.GetLength();
	if (strRoot.GetLength() < 4)
	{
		CString strPad(_T(' '), 4 - nLen);
		strRoot += strPad;
	}
	strRoot.MakeUpper();
	m_Dictionary[_T("MAC_TYPE")] = strRoot;


	// Return NULL to indicate there are no more steps.
	if (pDlg==NULL)
	{
		CStep0Dlg * dlg=NULL;
		dlg=new CStep0Dlg;
		return dlg;
	}
	if (pDlg->m_nIDTemplate==CStep0Dlg::IDD)
	{
		CStep1Dlg * dlg=NULL;
		dlg=new CStep1Dlg;
		return dlg;
	}
	if (pDlg->m_nIDTemplate==CStep1Dlg::IDD)
	{
		CStep2Dlg * dlg=NULL;
		dlg=new CStep2Dlg;
		return dlg;
	}
	if (pDlg->m_nIDTemplate==CStep2Dlg::IDD)
	{
    	if (m_Dictionary[_T("emptyproject")] == "1")
            // don't show final page for empty project option
            return NULL;
        else {
		    CStep3Dlg * dlg=NULL;
		    dlg=new CStep3Dlg;
		    return dlg;
        }
	}

	return NULL;
}

/////////////////////////////////////
// CCustomAppWiz::CustomizeProject
/////////////////////////////////////
void CWxWinWizAppWiz::CustomizeProject(IBuildProject* pProject)
{
	// TODO: Add code here to customize the project.  If you don't wish
	//  to customize project, you may remove this virtual override.
	
	// This is called immediately after the default Debug and Release
	//  configurations have been created for each platform.  You may customize
	//  existing configurations on this project by using the methods
	//  of IBuildProject and IConfiguration such as AddToolSettings,
	//  RemoveToolSettings, and AddCustomBuildStep. These are documented in
	//  the Developer Studio object model documentation.

	// WARNING!!  IBuildProject and all interfaces you can get from it are OLE
	//  COM interfaces.  You must be careful to release all new interfaces
	//  you acquire.  In accordance with the standard rules of COM, you must
	//  NOT release pProject, unless you explicitly AddRef it, since pProject
	//  is passed as an "in" parameter to this function.  See the documentation
	//  on CCustomAppWiz::CustomizeProject for more information.


	// version 0.6 (M@)
	long cnt;
	VARIANT vBlank;
	VariantInit(&vBlank);
	IConfigurations* configs;
	pProject->AddConfiguration(_bstr_t("DebugDLL"),vBlank);	
	pProject->AddConfiguration(_bstr_t("ReleaseDLL"),vBlank);	

	HRESULT hr = pProject->get_Configurations(&configs);

	if(FAILED(hr))
	{
		MessageBox(NULL,"Wizard Project Error. Your project settings may be corrupted.",NULL,MB_ICONWARNING);
		return;
	}



	configs->get_Count(&cnt);

	for (long i=1;i<=cnt;i++)
	{
		_variant_t vnBlank = i;

		BSTR nm;
		IConfiguration* cfg;

		configs->Item(_variant_t(i),&cfg);
		cfg->get_Name(&nm);

		CString str = nm;
		pProject->get_Name(&nm);

		CString name = nm;
		m_sProject_Name = nm ;

		//AddToolSettings MFC = None : 0, Static Libraries : 1, Shared Dll : 2
		cfg->AddToolSettings(_bstr_t("mfc"),_bstr_t((long)0),vnBlank);


		if (str.Find("Debug",0)!=-1)
		{
			if (str.Find("DebugDLL",0)!=-1)
				CfgSetDebugDLL(cfg, name, vnBlank) ;
			else
				CfgSetDebug(cfg, name, vnBlank) ;
		}	
		else
		{
			if (str.Find("ReleaseDLL",0)!=-1)
				CfgSetReleaseDLL(cfg, name, vnBlank) ;
			else
				CfgSetRelease(cfg, name, vnBlank) ;
		}

		cfg->Release();
	}
	configs->Release();
}


//////////////////////////////////////////////////////////////////////////////
//				SETS OPTIONS FOR RELEASE-DLL MODE
//////////////////////////////////////////////////////////////////////////////
void 
CWxWinWizAppWiz::CfgSetReleaseDLL(IConfiguration *cfg, CString name, VARIANT vBlank)
{
	_bstr_t varTool;
	_bstr_t varSwitch;
	varTool   = _bstr_t("cl.exe");

    CString base = m_Dictionary[_T("wxbasedir")];
    CString xrc = m_Dictionary[_T("usexrc")];


// Settare "Not using precompiled header"

	varSwitch = "/ZI";
	cfg->RemoveToolSettings(varTool, varSwitch, vBlank);
	varSwitch = "/GZ";
	cfg->RemoveToolSettings(varTool, varSwitch, vBlank);

	varSwitch = "/YX";	// "Not using precompiled header"
	cfg->RemoveToolSettings(varTool, varSwitch, vBlank);

	//ReleaseDLL configuration for cfg (M@)
//	(M@)Preprocessor = NDEBUG,WIN32,_WINDOWS,__WINDOWS__,__WXMSW__,__WIN95__,__WIN32__,WINVER=0x0400,STRICT,WXUSINGDLL=1

//	CString settings="/nologo /MD /W4 /O2 /D \"NDEBUG\" /D \"WIN32\" /D \"_WINDOWS\" /D \"__WINDOWS__\" /D \"__WXMSW__\" /D \"__WIN95__\" /D \"__WIN32__\" /D WINVER=0x0400 /D \"STRICT\" /D WXUSINGDLL=1 /Fo\"ReleaseDLL/\" /Fd\"ReleaseDLL/\" /FD /c";
	CString settings;
	settings.Format("/nologo /MD /W4 /O2 /I \"%s\\lib\\mswdll\" /I \"%s\\include\" /I \"%s\\contrib\\include\" /D \"NDEBUG\" /D \"WIN32\" /D \"_WINDOWS\" /D \"__WINDOWS__\" /D \"__WXMSW__\" /D \"__WIN95__\" /D \"__WIN32__\" /D WINVER=0x0400 /D \"STRICT\" /D WXUSINGDLL=1 /Fo\"ReleaseDLL/\" /Fd\"ReleaseDLL/\" /FD /c", base, base, base);

	cfg->AddToolSettings(_bstr_t("cl.exe"),settings.AllocSysString(),vBlank);



	settings.Format("kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib comctl32.lib rpcrt4.lib wsock32.lib winmm.lib wxmsw24.lib /nologo /subsystem:windows /incremental:no /pdb:\"ReleaseDLL/%s.pdb\" /machine:I386 /nodefaultlib:\"libc.lib\" /nodefaultlib:\"libci.lib\"",name,name);
	cfg->AddToolSettings(_bstr_t("link.exe"),settings.AllocSysString(),vBlank);

	varSwitch = "/Fp";
	cfg->RemoveToolSettings(varTool, varSwitch, vBlank);
	CString fn;
	fn.Format("%sApp.cpp",name);
//	settings.Format("/Fp\"ReleaseDLL/%s.pch\" /Yc\"wx/wxprec.h\"",name);
	settings.Format("/Fp\"ReleaseDLL/%s.pch\" /YX\"wxprec.h\"",name);
	cfg->AddFileSettings(fn.AllocSysString(),settings.AllocSysString(),vBlank);

}


//////////////////////////////////////////////////////////////////////////////
//				SETS OPTIONS FOR DEBUG-DLL MODE
//////////////////////////////////////////////////////////////////////////////
void 
CWxWinWizAppWiz::CfgSetDebugDLL(IConfiguration *cfg, CString name, VARIANT vBlank)
{
	_bstr_t varTool;
	_bstr_t varSwitch;
	varTool   = _bstr_t("cl.exe");

    CString base = m_Dictionary[_T("wxbasedir")];
    CString xrc = m_Dictionary[_T("usexrc")];


	//(M@) DebugDLL configuration for cfg

//	(M@)Preprocessor = WIN32,_DEBUG,_WINDOWS,__WINDOWS__,__WXMSW__,DEBUG=1,__WXDEBUG__,__WIN95__,__WIN32__,WINVER=0x0400,STRICT,WXUSINGDLL=1

    CString settings;
//	22/11
//	settings.Format("/nologo /MDd /W4 /Zi /Od /I \"%s\\lib\\mswd\" /I \"%s\\include\" /I \"%s\\contrib\\include\" /D \"WIN32\" /D \"_DEBUG\" /D \"_WINDOWS\" /D WINVER=0x400 /D \"_MT\" /D wxUSE_GUI=1 /D \"__WXDEBUG__\" /D WXDEBUG=1 /D WXUSINGDLL=1 /Fp\"DebugDLL/%s.pch\" /YX /Fo\"DebugDLL/\" /Fd\"DebugDLL/\" /FD /c",base, base, base, name);
	settings.Format("/nologo /MDd /W4 /Zi /Od /I \"%s\\lib\\mswd\" /I \"%s\\include\" /I \"%s\\contrib\\include\" /D \"WIN32\" /D \"_DEBUG\" /D \"_WINDOWS\" /D WINVER=0x400 /D \"_MT\" /D wxUSE_GUI=1 /D \"__WXDEBUG__\" /D WXDEBUG=1 /D WXUSINGDLL=1 /Fp\"DebugDLL/%s.pch\" /YX\"wxprec.h\" /Fo\"DebugDLL/\" /Fd\"DebugDLL/\" /FD /c",base, base, base, name);

	cfg->AddToolSettings(_bstr_t("cl.exe"),settings.AllocSysString(),vBlank);

	cfg->AddToolSettings(_bstr_t("cl.exe"),settings.AllocSysString(),vBlank);
	settings.Format("kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib comctl32.lib rpcrt4.lib wsock32.lib winmm.lib wxmsw24d.lib /nologo /subsystem:windows /incremental:yes /pdb:\"DebugDLL/%s.pdb\" /debug /machine:I386 /nodefaultlib:\"libcd.lib\" /nodefaultlib:\"libcid.lib\" /pdbtype:sept",name,name);
	cfg->AddToolSettings(_bstr_t("link.exe"),settings.AllocSysString(),vBlank);

	CString fn;
	fn.Format("%sApp.cpp",name);
//	settings.Format("/Fp\"DebugDLL/%s.pch\" /Yc\"wx/wxprec.h\"",name);	22/11
	settings.Format("/Fp\"DebugDLL/%s.pch\" /YX\"wxprec.h\"",name);
	cfg->AddFileSettings(fn.AllocSysString(),settings.AllocSysString(),vBlank);
}


//////////////////////////////////////////////////////////////////////////////
//				SETS OPTIONS FOR RELEASE MODE
//////////////////////////////////////////////////////////////////////////////
void 
CWxWinWizAppWiz::CfgSetRelease(IConfiguration *cfg, CString name, VARIANT vBlank)
{
	_bstr_t varTool;
	_bstr_t varSwitch;
	varTool   = _bstr_t("cl.exe");

    CString base = m_Dictionary[_T("wxbasedir")];
    CString xrc = m_Dictionary[_T("usexrc")];


	//Release configuration for cfg
    CString settings;
//	22/11
//	settings.Format("/nologo /MD /W4 /O2 /I \"%s\\lib\\msw\" /I \"%s\\include\" /I \"%s\\contrib\\include\" /D \"NDEBUG\" /D \"WIN32\" /D \"_WINDOWS\" /D WINVER=0x400 /D \"_MT\" /D wxUSE_GUI=1 /Fp\"Release/%s.pch\" /YX /Fo\"Release/\" /Fd\"Release/\" /FD /c",base, base, base, name);
	settings.Format("/nologo /MD /W4 /O2 /I \"%s\\lib\\msw\" /I \"%s\\include\" /I \"%s\\contrib\\include\" /D \"NDEBUG\" /D \"WIN32\" /D \"_WINDOWS\" /D WINVER=0x400 /D \"_MT\" /D wxUSE_GUI=1 /Fp\"Release/%s.pch\" /YX\"wxprec.h\" /Fo\"Release/\" /Fd\"Release/\" /FD /c",base, base, base, name);
	cfg->AddToolSettings(_bstr_t("cl.exe"),settings.AllocSysString(),vBlank);

    if (xrc == "1")
        settings.Format("comctl32.lib rpcrt4.lib wsock32.lib zlib.lib regex.lib png.lib jpeg.lib tiff.lib wxmsw.lib wxxrc.lib /libpath:\"%s/lib\" /libpath:\"%s/contrib/lib\" /nologo /subsystem:windows /incremental:no /pdb:\"Release/%s.pdb\" /machine:I386 /out:\"Release/%s.exe\"", base, base, name, name);
    else
        settings.Format("comctl32.lib rpcrt4.lib wsock32.lib zlib.lib regex.lib png.lib jpeg.lib tiff.lib wxmsw.lib /libpath:\"%s/lib\" /libpath:\"%s/contrib/lib\" /nologo /subsystem:windows /incremental:no /pdb:\"Release/%s.pdb\" /machine:I386 /out:\"Release/%s.exe\"", base, base, name, name);

	cfg->AddToolSettings(_bstr_t("link.exe"),settings.AllocSysString(),vBlank);
	settings.Format("/i \"%s\\include", base);
    cfg->AddToolSettings(_bstr_t("rc.exe"), settings.AllocSysString(), vBlank);
/*
    CString fn;
	fn.Format("%sApp.cpp",name);
	settings.Format("/Fp\"Release/%s.pch\" /YX",name);
	cfg->AddFileSettings(fn.AllocSysString(),settings.AllocSysString(),vBlank);
*/
}

//////////////////////////////////////////////////////////////////////////////
//				SETS OPTIONS FOR DEBUG MODE
//////////////////////////////////////////////////////////////////////////////

void 
CWxWinWizAppWiz::CfgSetDebug(IConfiguration *cfg, CString name, VARIANT vBlank)
{
	_bstr_t varTool;
	_bstr_t varSwitch;
	varTool   = _bstr_t("cl.exe");

    CString base = m_Dictionary[_T("wxbasedir")];
    CString xrc = m_Dictionary[_T("usexrc")];


	//Debug configuration for cfg
	CString settings;
//	22/11
//	settings.Format("/nologo /MDd /W4 /Zi /Od /I \"%s\\lib\\msw\" /I \"%s\\include\" /I \"%s\\contrib\\include\" /D \"WIN32\" /D \"_DEBUG\" /D \"_WINDOWS\" /D WINVER=0x400 /D \"_MT\" /D wxUSE_GUI=1 /D \"__WXDEBUG__\" /D WXDEBUG=1 /Fp\"Debug/%s.pch\" /YX /Fo\"Debug/\" /Fd\"Debug/\" /FD /c",base, base, base, name);
	settings.Format("/nologo /MDd /W4 /Zi /Od /I \"%s\\lib\\msw\" /I \"%s\\include\" /I \"%s\\contrib\\include\" /D \"WIN32\" /D \"_DEBUG\" /D \"_WINDOWS\" /D WINVER=0x400 /D \"_MT\" /D wxUSE_GUI=1 /D \"__WXDEBUG__\" /D WXDEBUG=1 /Fp\"Debug/%s.pch\" /YX\"wxprec.h\" /Fo\"Debug/\" /Fd\"Debug/\" /FD /c",base, base, base, name);
	cfg->AddToolSettings(_bstr_t("cl.exe"),settings.AllocSysString(),vBlank);

    if (xrc == "1") 
        settings.Format("comctl32.lib rpcrt4.lib wsock32.lib zlibd.lib regexd.lib pngd.lib jpegd.lib tiffd.lib wxmswd.lib wxxrcd.lib /libpath:\"%s/lib\" /libpath:\"%s/contrib/lib\" /nologo /subsystem:windows /incremental:yes /pdb:\"Debug/%s.pdb\" /debug /machine:I386 /out:\"Debug/%s.exe\" /pdbtype:sept", base, base, name, name);
    else
        settings.Format("comctl32.lib rpcrt4.lib wsock32.lib zlibd.lib regexd.lib pngd.lib jpegd.lib tiffd.lib wxmswd.lib /libpath:\"%s/lib\" /libpath:\"%s/contrib/lib\" /nologo /subsystem:windows /incremental:yes /pdb:\"Debug/%s.pdb\" /debug /machine:I386 /out:\"Debug/%s.exe\" /pdbtype:sept", base, base, name, name);

	cfg->AddToolSettings(_bstr_t("link.exe"),settings.AllocSysString(),vBlank);

	settings.Format("/i \"%s\\include", base);
    cfg->AddToolSettings(_bstr_t("rc.exe"), settings.AllocSysString(), vBlank);

/*
    CString fn;
	fn.Format("%sApp.cpp",name);
	settings.Format("/Fp\"Debug/%s.pch\" /YX",name);
	cfg->AddFileSettings(fn.AllocSysString(),settings.AllocSysString(),vBlank);
*/
}